#include "mod_basic.h"

char *mod_basic_info_x(xmlnode user, char *item)
{
    xmlnode next, info;

    info = xmlnode_get_tag(user,"info");
    if(info == NULL)
        info = xmlnode_insert_tag(user,"info");
    next = xmlnode_get_firstchild(info);
    while(next != NULL)
    {
        if(xmlnode_get_type(next) == NTYPE_TAG && j_strcmp(xmlnode_get_name(next),item) == 0)
            return xmlnode_get_data(xmlnode_get_firstchild(next));
        next = xmlnode_get_nextsibling(next);
    }

    return NULL;
}

void mod_basic_info_get(char *user, xmlnode query)
{
    xmlnode next, x;

    if(user == NULL || query == NULL)
        return;

    jdebug(ZONE,"MOD_BASIC: %s info get",user);

    x = mod_basic_data_manager(user,NULL);
    next = xmlnode_get_firstchild(query);
    while(next != NULL)
    {
        if(xmlnode_get_type(next) == NTYPE_TAG)
        {
            if(j_strcmp(xmlnode_get_name(next),"type") == 0)
                xmlnode_insert_cdata(next,"user",6);
            else
               xmlnode_insert_cdata(next,mod_basic_info_x(x,xmlnode_get_name(next)),-1);
        }
        next = xmlnode_get_nextsibling(next);
    }
    xmlnode_free(x);
}

void mod_basic_info_set(char *user, xmlnode query)
{
    xmlnode x, info, c;

    if(user == NULL || query == NULL)
        return;

    jdebug(ZONE,"MOD_BASIC: %s info set",user);

    x = mod_basic_data_manager(user,NULL);
    xmlnode_hide(xmlnode_get_tag(x,"info"));
    info = xmlnode_insert_tag(x,"info");
    xmlnode_insert_node(info,xmlnode_get_firstchild(query));
    for(c = xmlnode_get_firstchild(query); c != NULL; c = xmlnode_get_nextsibling(c))
        xmlnode_hide(c);
    mod_basic_data_manager(user,x);
    xmlnode_free(x);
}

