#include "jserver.h"
#include "dlfcn.h"

/* loads the shared object and calls the init function */
void *dso_load(char *so, char *init, void *arg)
{
    void (*init_h)(void *arg);
    void *so_h;
    char *dlerr;

    jdebug(ZONE,"dso_init");

    if(so == NULL)
        return NULL;

    so_h = dlopen(so,RTLD_LAZY);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        jerror("jserver","dso load %s failed: %s",so,dlerr);
        return NULL;
    }

    if(init == NULL)
        return so_h;

    init_h = dlsym(so_h,init);
    dlerr = dlerror();
    if(dlerr != NULL)
    {
        jerror("jserver","dso call %s in %s failed: %s",init,so,dlerr);
        dlclose(so_h);
        return NULL;
    }
    (init_h)(arg);

    return so_h;
}



