#include "jserver.h"

thread logger_device = NULL;

void logger_init(xmlnode x)
{
    int fd;
    char *file;

    file = xmlnode_get_data(xmlnode_get_firstchild(x));
    fd = open(file, O_WRONLY | O_CREAT | O_APPEND, 0600);
    if(file == NULL || fd < 0)
    {
        jerror("jserver","unable to open log file");
        return;
    }

    if(logger_device != NULL)
    {
        pth_cancel(logger_device->id); /* hmmm, does this thread get canceled before the new one starts? */
    }

    logger_device = tstream_new(fd,"logger",NULL,NULL,NULL);
}

/* logs session characteristics */
void logger_session(session s)
{
    static char log[LOGSIZE_HDR];
    int size;

    if(logger_device == NULL)
        return;

jdebug(ZONE,"before");
    size = snprintf(log, LOGSIZE_HDR, "%s session %s %d %d %d\n",
					create_log_timestamp(),jid_full(s->id),10,
					s->in_count, s->out_count);
    tstream_write(logger_device,log,size);
}

/* logs session characteristics */
void logger_registration(char *host, char *user)
{
    static char log[LOGSIZE_HDR];
    int size;

    if(logger_device == NULL)
        return;

    size = snprintf(log, LOGSIZE_HDR, "registration %s %s %s\n",host,"timestamp",user);
    tstream_write(logger_device,log,size);
}
