#include "jserver.h"
#include <getopt.h>

/* this file is only for the executable version of the jabber server */

int main (int argc, char** argv)
{
    pth_event_t sigevt;
    sigset_t set;
    int help, sig, i, sz;
    char *etherx, *cfgfile, *secret;
    struct option options[] =
    {
        {"config",1,0,'c'},
        {"etherx",1,0,'e'},
        {"secret",1,0,'s'},
        {0,0,0,0}
    };

    cfgfile = etherx = secret = NULL;
    help = opterr = 0;
    while((sig = getopt_long(argc,argv,"c:e:s:D",options,NULL)) > 0)
    {
        switch(sig)
        {
            case 'D':
                jlib_debug();
                break;
            case 'c':
                cfgfile = strdup(optarg);
                break;
            case 'e':
                etherx = strdup(optarg);
                break;
            case 's':
                secret = strdup(optarg);
				sz = strlen(optarg);
				for(i=0;i<sz;i++)
					optarg[i]='x';
                break;
            default:
                help = 1;
        }
    }
 
    if(help || secret == NULL)
    {
        printf("Usage:\njserver -s secret [-e etherx.host] [-c config.xml]\n");
        exit(0);
    }
 
    if(etherx == NULL)
        etherx = strdup("127.0.0.1");

    jlib_init(JLIB_LOG_STDERR, NULL);

    jwarn("jserver","starting transport");

    etherx_init(secret,etherx);

    /* optionally pre-load the config if it was manually set */
    if(cfgfile != NULL)
        js_config = xmlnode_file(cfgfile);

    js_init();

    sigemptyset(&set);
    sigaddset(&set, SIGHUP);
    sigaddset(&set, SIGINT);
    sigaddset(&set, SIGTERM);
    pth_sigmask(SIG_UNBLOCK, &set, NULL);
    sigevt = pth_event(PTH_EVENT_SIGS, &set, &sig);
 
    jdebug(ZONE,"Main loop waiting");
    pth_wait(sigevt);

    jerror("jserver","Received KILL, shutting down");
    shutdown_now();
    pth_yield(NULL); /* one last chance to make sure everyone is done */
    pth_kill();
    return 0;
}
