#include "jserver.h"

void *server_main(void *arg)
{
    /* thread that handles messages/packets intended for the server
     * - administration
     * - public IQ (agents, etc)
     */
    pth_event_t ev;
    pth_msgport_t mp;
    jpq q;
    mapi m;
    
    jdebug(ZONE,"THREAD:SERVER starting");

    mp = pth_msgport_create("server");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            jdebug(ZONE,"THREAD:SERVER received a packet!");

            if(NSCHECK(xmlnode_get_tag(q->p->x,"query"),"jabber:iq:info") && 
               xmlnode_get_tag(js_config,"info") != NULL && 
               j_strcmp(xmlnode_get_attrib(q->p->x,"type"),"get") == 0)                                              
            {
                server_info(q->p);
                deliver(jpacket_new(js_iqreply(q->p->x)));
                continue;
            }

            if(NSCHECK(xmlnode_get_tag(q->p->x,"query"),"jabber:iq:agents") && 
               xmlnode_get_tag(js_config,"agents") != NULL && 
               j_strcmp(xmlnode_get_attrib(q->p->x,"type"),"get") == 0)                                              
            {
                server_agents(q->p);
                deliver(jpacket_new(js_iqreply(q->p->x)));
                continue;
            }

            m = mapi_new(M_PHASE_SERVER,q->p->p,NULL,q->p);
            module_dispatch(m);
            if(m->result == M_DEFAULT)
            {
                if(q->p->type == JPACKET_MESSAGE && xmlnode_get_tag(js_config,"admin") != NULL)
                {
                    xmlnode_put_attrib(q->p->x,"to",xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(js_config,"admin"))));
                    deliver(jpacket_new(q->p->x));
                }else{
                    js_bounce(q->p->x,TERROR_DELIVERY,"This server did not recognize your request");
                }
            }else{
                xmlnode_free(q->p->x);
            }
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}

void server_info(jpacket p)
{
   xmlnode next;
 
    jdebug(ZONE,"MOD_BASIC: server info request");
 
    next = xmlnode_get_firstchild(xmlnode_get_tag(p->x,"query"));
    while(next != NULL)
    {
        if(xmlnode_get_type(next) == NTYPE_TAG)
        {
            if(j_strcmp(xmlnode_get_name(next),"type") == 0)
                xmlnode_insert_cdata(next,"server",6);
            else
                xmlnode_insert_cdata(next,xmlnode_get_data(xmlnode_get_firstchild(xmlnode_get_tag(xmlnode_get_tag(js_config,"info"),xmlnode_get_name(next)))),-1);
        }
        next = xmlnode_get_nextsibling(next);
    }
}

void server_agents(jpacket p)
{
    jdebug(ZONE,"MOD_BASIC: server agent request");

    xmlnode_insert_node(xmlnode_get_tag(p->x,"query"),xmlnode_get_firstchild(xmlnode_get_tag(js_config,"agents"))); 
}

void server_agent(char *id)
{
    xmlnode_insert_cdata(xmlnode_insert_tag(xmlnode_get_tag(js_config,"agents"),"id"),id,strlen(id));
}
