#include "jserver.h"

/* thread that handles data for unknown resources, 
 * might be for offline users, etc */

void *unknown_main(void *arg)
{
    pth_event_t ev;
    pth_msgport_t mp;
    mapi m;
    jpq q;
    
    jdebug(ZONE,"THREAD:UNKNOWN starting");

    mp = pth_msgport_create("unknown");
    ev = pth_event(PTH_EVENT_MSG,mp);

    while(1)
    {
        pth_wait(ev);
        while((q = (jpq)pth_msgport_get(mp)) != NULL)
        {
            jdebug(ZONE,"THREAD:UNKNOWN received a message: %s",xmlnode2str(q->p->x));
            m = mapi_new(M_PHASE_UNKNOWN,q->p->p,NULL,q->p);
            m->user = q->p->to->user;
            m->resource = q->p->to->resource;
            module_dispatch(m);
            if(m->result == M_DEFAULT)
                js_bounce(q->p->x,TERROR_DELIVERY,"Unknown Recipient");
            else
                xmlnode_free(q->p->x);
        }
    }
    
    pth_event_free(ev,PTH_FREE_ALL);
    pth_msgport_destroy(mp);
}

